> ## Documentation Index
> Fetch the complete documentation index at: https://wb-21fd5541-update-serverless-training-api-9.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Log

> Log trajectories and calculate metrics.



## OpenAPI

````yaml /serverless-training/api-reference/openapi.json post /v1/preview/models/{model_id}/log
openapi: 3.1.0
info:
  title: Serverless Training
  version: 1.0.0
servers:
  - url: https://api.training.wandb.ai
security: []
paths:
  /v1/preview/models/{model_id}/log:
    post:
      tags:
        - models
      summary: Log
      description: Log trajectories and calculate metrics.
      operationId: log_v1_preview_models__model_id__log_post
      parameters:
        - name: model_id
          in: path
          required: true
          schema:
            type: string
            title: Model Id
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/LogRequest'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema: {}
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    LogRequest:
      properties:
        split:
          type: string
          title: Split
        trajectory_groups:
          items:
            $ref: '#/components/schemas/TrajectoryGroup'
          type: array
          title: Trajectory Groups
      type: object
      required:
        - split
        - trajectory_groups
      title: LogRequest
      description: Schema for logging trajectories.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    TrajectoryGroup:
      properties:
        trajectories:
          items:
            $ref: '#/components/schemas/Trajectory'
          type: array
          title: Trajectories
        exceptions:
          items:
            $ref: '#/components/schemas/PydanticException'
          type: array
          title: Exceptions
        metadata:
          additionalProperties: true
          type: object
          title: Metadata
        metrics:
          additionalProperties:
            anyOf:
              - type: number
              - type: integer
              - type: boolean
          type: object
          title: Metrics
        logs:
          items:
            type: string
          type: array
          title: Logs
      type: object
      title: TrajectoryGroup
      description: ART trajectory group, including exchange and group-level state.
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    Trajectory:
      properties:
        exchanges:
          $ref: '#/components/schemas/TrajectoryExchanges'
        messages_and_choices:
          items:
            anyOf:
              - $ref: '#/components/schemas/ChatCompletionDeveloperMessageParam'
              - $ref: '#/components/schemas/ChatCompletionSystemMessageParam'
              - $ref: '#/components/schemas/ChatCompletionUserMessageParam'
              - $ref: '#/components/schemas/ChatCompletionAssistantMessageParam'
              - $ref: '#/components/schemas/ChatCompletionToolMessageParam'
              - $ref: '#/components/schemas/ChatCompletionFunctionMessageParam'
              - $ref: '#/components/schemas/Choice'
          type: array
          title: Messages And Choices
        tools:
          anyOf:
            - items:
                $ref: '#/components/schemas/ChatCompletionFunctionToolParam'
              type: array
            - type: 'null'
          title: Tools
        additional_histories:
          items:
            $ref: '#/components/schemas/History'
          type: array
          title: Additional Histories
        reward:
          type: number
          title: Reward
          default: 0
        initial_policy_version:
          anyOf:
            - type: integer
            - type: 'null'
          title: Initial Policy Version
        final_policy_version:
          anyOf:
            - type: integer
            - type: 'null'
          title: Final Policy Version
        metrics:
          additionalProperties:
            anyOf:
              - type: number
              - type: integer
              - type: boolean
          type: object
          title: Metrics
        metadata:
          additionalProperties: true
          type: object
          title: Metadata
        logs:
          items:
            type: string
          type: array
          title: Logs
        start_time:
          type: string
          format: date-time
          title: Start Time
      additionalProperties: true
      type: object
      title: Trajectory
      description: Preserve trajectory fields added by newer ART producers.
    PydanticException:
      properties:
        type:
          type: string
          title: Type
        message:
          type: string
          title: Message
        traceback:
          type: string
          title: Traceback
      type: object
      required:
        - type
        - message
        - traceback
      title: PydanticException
    TrajectoryExchanges:
      properties:
        chat_completions:
          items:
            $ref: '#/components/schemas/ChatCompletionsExchange'
          type: array
          title: Chat Completions
        completions:
          items:
            $ref: '#/components/schemas/CompletionsExchange'
          type: array
          title: Completions
        responses:
          items:
            $ref: '#/components/schemas/ResponsesExchange'
          type: array
          title: Responses
        messages:
          items:
            $ref: '#/components/schemas/MessagesExchange'
          type: array
          title: Messages
      type: object
      title: TrajectoryExchanges
    ChatCompletionDeveloperMessageParam:
      properties:
        content:
          anyOf:
            - type: string
            - items:
                $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
              type: array
          title: Content
        role:
          type: string
          const: developer
          title: Role
        name:
          type: string
          title: Name
      additionalProperties: true
      type: object
      required:
        - content
        - role
      title: ChatCompletionDeveloperMessageParam
      description: >-
        Developer-provided instructions that the model should follow, regardless
        of

        messages sent by the user. With o1 models and newer, `developer`
        messages

        replace the previous `system` messages.
    ChatCompletionSystemMessageParam:
      properties:
        content:
          anyOf:
            - type: string
            - items:
                $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
              type: array
          title: Content
        role:
          type: string
          const: system
          title: Role
        name:
          type: string
          title: Name
      additionalProperties: true
      type: object
      required:
        - content
        - role
      title: ChatCompletionSystemMessageParam
      description: >-
        Developer-provided instructions that the model should follow, regardless
        of

        messages sent by the user. With o1 models and newer, use `developer`
        messages

        for this purpose instead.
    ChatCompletionUserMessageParam:
      properties:
        content:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
                  - $ref: '#/components/schemas/ChatCompletionContentPartImageParam'
                  - $ref: >-
                      #/components/schemas/ChatCompletionContentPartInputAudioParam
                  - $ref: '#/components/schemas/File'
              type: array
          title: Content
        role:
          type: string
          const: user
          title: Role
        name:
          type: string
          title: Name
      additionalProperties: true
      type: object
      required:
        - content
        - role
      title: ChatCompletionUserMessageParam
      description: |-
        Messages sent by an end user, containing prompts or additional context
        information.
    ChatCompletionAssistantMessageParam:
      properties:
        role:
          type: string
          const: assistant
          title: Role
        audio:
          anyOf:
            - $ref: '#/components/schemas/Audio'
            - type: 'null'
        content:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
                  - $ref: '#/components/schemas/ChatCompletionContentPartRefusalParam'
              type: array
            - type: 'null'
          title: Content
        function_call:
          anyOf:
            - $ref: '#/components/schemas/FunctionCall'
            - type: 'null'
        name:
          type: string
          title: Name
        refusal:
          anyOf:
            - type: string
            - type: 'null'
          title: Refusal
        tool_calls:
          items:
            anyOf:
              - $ref: >-
                  #/components/schemas/ChatCompletionMessageFunctionToolCallParam
              - $ref: '#/components/schemas/ChatCompletionMessageCustomToolCallParam'
          type: array
          title: Tool Calls
      additionalProperties: true
      type: object
      required:
        - role
      title: ChatCompletionAssistantMessageParam
      description: Messages sent by the model in response to user messages.
    ChatCompletionToolMessageParam:
      properties:
        content:
          anyOf:
            - type: string
            - items:
                $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
              type: array
          title: Content
        role:
          type: string
          const: tool
          title: Role
        tool_call_id:
          type: string
          title: Tool Call Id
      additionalProperties: true
      type: object
      required:
        - content
        - role
        - tool_call_id
      title: ChatCompletionToolMessageParam
    ChatCompletionFunctionMessageParam:
      properties:
        content:
          anyOf:
            - type: string
            - type: 'null'
          title: Content
        name:
          type: string
          title: Name
        role:
          type: string
          const: function
          title: Role
      additionalProperties: true
      type: object
      required:
        - content
        - name
        - role
      title: ChatCompletionFunctionMessageParam
    Choice:
      properties:
        finish_reason:
          type: string
          enum:
            - stop
            - length
            - tool_calls
            - content_filter
            - function_call
          title: Finish Reason
        index:
          type: integer
          title: Index
        logprobs:
          anyOf:
            - $ref: '#/components/schemas/ChoiceLogprobs'
            - type: 'null'
        message:
          $ref: '#/components/schemas/ChatCompletionMessage'
      additionalProperties: true
      type: object
      required:
        - finish_reason
        - index
        - message
      title: Choice
    ChatCompletionFunctionToolParam:
      properties:
        function:
          $ref: '#/components/schemas/FunctionDefinition'
        type:
          type: string
          const: function
          title: Type
      additionalProperties: true
      type: object
      required:
        - function
        - type
      title: ChatCompletionFunctionToolParam
      description: A function tool that can be used to generate a response.
    History:
      properties:
        messages_and_choices:
          items:
            anyOf:
              - $ref: '#/components/schemas/ChatCompletionDeveloperMessageParam'
              - $ref: '#/components/schemas/ChatCompletionSystemMessageParam'
              - $ref: '#/components/schemas/ChatCompletionUserMessageParam'
              - $ref: '#/components/schemas/ChatCompletionAssistantMessageParam'
              - $ref: '#/components/schemas/ChatCompletionToolMessageParam'
              - $ref: '#/components/schemas/ChatCompletionFunctionMessageParam'
              - $ref: '#/components/schemas/Choice'
          type: array
          title: Messages And Choices
        tools:
          anyOf:
            - items:
                $ref: '#/components/schemas/ChatCompletionFunctionToolParam'
              type: array
            - type: 'null'
          title: Tools
      type: object
      required:
        - messages_and_choices
      title: History
    ChatCompletionsExchange:
      properties:
        request:
          $ref: '#/components/schemas/ChatCompletionsRequest'
          title: Request
        response:
          $ref: '#/components/schemas/ChatCompletion'
        start_time:
          type: string
          format: date-time
          title: Start Time
        end_time:
          type: string
          format: date-time
          title: End Time
      type: object
      required:
        - request
        - response
        - start_time
        - end_time
      title: ChatCompletionsExchange
    CompletionsExchange:
      properties:
        request:
          $ref: '#/components/schemas/CompletionsRequest'
          title: Request
        response:
          $ref: '#/components/schemas/Completion'
        start_time:
          type: string
          format: date-time
          title: Start Time
        end_time:
          type: string
          format: date-time
          title: End Time
      type: object
      required:
        - request
        - response
        - start_time
        - end_time
      title: CompletionsExchange
    ResponsesExchange:
      properties:
        request:
          $ref: '#/components/schemas/ResponsesRequest'
          title: Request
        response:
          $ref: '#/components/schemas/Response'
        start_time:
          type: string
          format: date-time
          title: Start Time
        end_time:
          type: string
          format: date-time
          title: End Time
      type: object
      required:
        - request
        - response
        - start_time
        - end_time
      title: ResponsesExchange
    MessagesExchange:
      properties:
        request:
          $ref: '#/components/schemas/MessagesRequest'
          title: Request
        response:
          $ref: '#/components/schemas/anthropic__types__message__Message'
        start_time:
          type: string
          format: date-time
          title: Start Time
        end_time:
          type: string
          format: date-time
          title: End Time
      type: object
      required:
        - request
        - response
        - start_time
        - end_time
      title: MessagesExchange
    ChatCompletionContentPartTextParam:
      properties:
        text:
          type: string
          title: Text
        type:
          type: string
          const: text
          title: Type
      type: object
      required:
        - text
        - type
      title: ChatCompletionContentPartTextParam
      description: >-
        Learn about [text
        inputs](https://platform.openai.com/docs/guides/text-generation).
    ChatCompletionContentPartImageParam:
      properties:
        image_url:
          $ref: '#/components/schemas/ImageURL'
        type:
          type: string
          const: image_url
          title: Type
      additionalProperties: true
      type: object
      required:
        - image_url
        - type
      title: ChatCompletionContentPartImageParam
      description: >-
        Learn about [image
        inputs](https://platform.openai.com/docs/guides/vision).
    ChatCompletionContentPartInputAudioParam:
      properties:
        input_audio:
          $ref: '#/components/schemas/InputAudio'
        type:
          type: string
          const: input_audio
          title: Type
      additionalProperties: true
      type: object
      required:
        - input_audio
        - type
      title: ChatCompletionContentPartInputAudioParam
      description: >-
        Learn about [audio
        inputs](https://platform.openai.com/docs/guides/audio).
    File:
      properties:
        file:
          $ref: '#/components/schemas/FileFile'
        type:
          type: string
          const: file
          title: Type
      additionalProperties: true
      type: object
      required:
        - file
        - type
      title: File
      description: >-
        Learn about [file inputs](https://platform.openai.com/docs/guides/text)
        for text generation.
    Audio:
      properties:
        id:
          type: string
          title: Id
      additionalProperties: true
      type: object
      required:
        - id
      title: Audio
      description: |-
        Data about a previous audio response from the model.
        [Learn more](https://platform.openai.com/docs/guides/audio).
    ChatCompletionContentPartRefusalParam:
      properties:
        refusal:
          type: string
          title: Refusal
        type:
          type: string
          const: refusal
          title: Type
      additionalProperties: true
      type: object
      required:
        - refusal
        - type
      title: ChatCompletionContentPartRefusalParam
    FunctionCall:
      properties:
        arguments:
          type: string
          title: Arguments
        name:
          type: string
          title: Name
      additionalProperties: true
      type: object
      required:
        - arguments
        - name
      title: FunctionCall
      description: >-
        Deprecated and replaced by `tool_calls`.


        The name and arguments of a function that should be called, as generated
        by the model.
    ChatCompletionMessageFunctionToolCallParam:
      properties:
        id:
          type: string
          title: Id
        function:
          $ref: '#/components/schemas/Function'
        type:
          type: string
          const: function
          title: Type
      additionalProperties: true
      type: object
      required:
        - id
        - function
        - type
      title: ChatCompletionMessageFunctionToolCallParam
      description: A call to a function tool created by the model.
    ChatCompletionMessageCustomToolCallParam:
      properties:
        id:
          type: string
          title: Id
        custom:
          $ref: '#/components/schemas/Custom'
        type:
          type: string
          const: custom
          title: Type
      additionalProperties: true
      type: object
      required:
        - id
        - custom
        - type
      title: ChatCompletionMessageCustomToolCallParam
      description: A call to a custom tool created by the model.
    ChoiceLogprobs:
      properties:
        content:
          anyOf:
            - items:
                $ref: '#/components/schemas/ChatCompletionTokenLogprob'
              type: array
            - type: 'null'
          title: Content
        refusal:
          anyOf:
            - items:
                $ref: '#/components/schemas/ChatCompletionTokenLogprob'
              type: array
            - type: 'null'
          title: Refusal
      additionalProperties: true
      type: object
      title: ChoiceLogprobs
      description: Log probability information for the choice.
    ChatCompletionMessage:
      properties:
        content:
          anyOf:
            - type: string
            - type: 'null'
          title: Content
        refusal:
          anyOf:
            - type: string
            - type: 'null'
          title: Refusal
        role:
          type: string
          const: assistant
          title: Role
        annotations:
          anyOf:
            - items:
                $ref: '#/components/schemas/Annotation'
              type: array
            - type: 'null'
          title: Annotations
        audio:
          anyOf:
            - $ref: '#/components/schemas/ChatCompletionAudio'
            - type: 'null'
        function_call:
          anyOf:
            - $ref: '#/components/schemas/FunctionCall'
            - type: 'null'
        tool_calls:
          anyOf:
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ChatCompletionMessageFunctionToolCall'
                  - $ref: '#/components/schemas/ChatCompletionMessageCustomToolCall'
              type: array
            - type: 'null'
          title: Tool Calls
      additionalProperties: true
      type: object
      required:
        - role
      title: ChatCompletionMessage
      description: A chat completion message generated by the model.
    FunctionDefinition:
      properties:
        name:
          type: string
          title: Name
        description:
          type: string
          title: Description
        parameters:
          additionalProperties: true
          type: object
          title: Parameters
        strict:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Strict
      additionalProperties: true
      type: object
      required:
        - name
      title: FunctionDefinition
    ChatCompletionsRequest:
      properties:
        model:
          type: string
          title: Model
        messages:
          items:
            anyOf:
              - $ref: '#/components/schemas/ChatCompletionDeveloperMessageParam'
              - $ref: '#/components/schemas/ChatCompletionSystemMessageParam'
              - $ref: '#/components/schemas/ChatCompletionUserMessageParam'
              - $ref: '#/components/schemas/ChatCompletionAssistantMessageParam'
              - $ref: '#/components/schemas/ChatCompletionToolMessageParam'
              - $ref: '#/components/schemas/ChatCompletionFunctionMessageParam'
          type: array
          title: Messages
        stream:
          type: boolean
          title: Stream
        tools:
          items:
            $ref: '#/components/schemas/ChatCompletionFunctionToolParam'
          type: array
          title: Tools
        max_completion_tokens:
          type: integer
          title: Max Completion Tokens
        max_tokens:
          type: integer
          title: Max Tokens
        temperature:
          type: number
          title: Temperature
        top_p:
          type: number
          title: Top P
        logprobs:
          type: boolean
          title: Logprobs
        top_logprobs:
          type: integer
          title: Top Logprobs
        chat_template:
          type: string
          title: Chat Template
        chat_template_kwargs:
          additionalProperties: true
          type: object
          title: Chat Template Kwargs
      additionalProperties: true
      type: object
      title: ChatCompletionsRequest
      description: The JSON body sent to an OpenAI-compatible Chat Completions endpoint.
    ChatCompletion:
      properties:
        id:
          type: string
          title: Id
        choices:
          items:
            $ref: '#/components/schemas/Choice'
          type: array
          title: Choices
        created:
          type: integer
          title: Created
        model:
          type: string
          title: Model
        object:
          type: string
          const: chat.completion
          title: Object
        service_tier:
          anyOf:
            - type: string
              enum:
                - auto
                - default
                - flex
                - scale
                - priority
            - type: 'null'
          title: Service Tier
        system_fingerprint:
          anyOf:
            - type: string
            - type: 'null'
          title: System Fingerprint
        usage:
          anyOf:
            - $ref: '#/components/schemas/CompletionUsage'
            - type: 'null'
      additionalProperties: true
      type: object
      required:
        - id
        - choices
        - created
        - model
        - object
      title: ChatCompletion
      description: >-
        Represents a chat completion response returned by model, based on the
        provided input.
    CompletionsRequest:
      properties:
        model:
          type: string
          title: Model
        prompt:
          anyOf:
            - type: string
            - items:
                type: string
              type: array
            - items:
                type: integer
              type: array
            - items:
                items:
                  type: integer
                type: array
              type: array
          title: Prompt
        stream:
          type: boolean
          title: Stream
        max_tokens:
          type: integer
          title: Max Tokens
        temperature:
          type: number
          title: Temperature
        top_p:
          type: number
          title: Top P
        logprobs:
          type: integer
          title: Logprobs
        echo:
          type: boolean
          title: Echo
        stop:
          anyOf:
            - type: string
            - items:
                type: string
              type: array
          title: Stop
        seed:
          type: integer
          title: Seed
      additionalProperties: true
      type: object
      title: CompletionsRequest
      description: The JSON body sent to an OpenAI-compatible Completions endpoint.
    Completion:
      properties:
        id:
          type: string
          title: Id
        choices:
          items:
            $ref: '#/components/schemas/CompletionChoice'
          type: array
          title: Choices
        created:
          type: integer
          title: Created
        model:
          type: string
          title: Model
        object:
          type: string
          const: text_completion
          title: Object
        system_fingerprint:
          anyOf:
            - type: string
            - type: 'null'
          title: System Fingerprint
        usage:
          anyOf:
            - $ref: '#/components/schemas/CompletionUsage'
            - type: 'null'
      additionalProperties: true
      type: object
      required:
        - id
        - choices
        - created
        - model
        - object
      title: Completion
      description: >-
        Represents a completion response from the API.


        Note: both the streamed and non-streamed response objects share the same
        shape (unlike the chat endpoint).
    ResponsesRequest:
      properties:
        model:
          type: string
          title: Model
        input:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/EasyInputMessageParam'
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__Message
                  - $ref: '#/components/schemas/ResponseOutputMessageParam'
                  - $ref: '#/components/schemas/ResponseFileSearchToolCallParam'
                  - $ref: '#/components/schemas/ResponseComputerToolCallParam'
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__ComputerCallOutput
                  - $ref: '#/components/schemas/ResponseFunctionWebSearchParam'
                  - $ref: '#/components/schemas/ResponseFunctionToolCallParam'
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__FunctionCallOutput
                  - $ref: '#/components/schemas/ResponseReasoningItemParam'
                  - $ref: '#/components/schemas/ResponseCompactionItemParamParam'
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__ImageGenerationCall
                  - $ref: '#/components/schemas/ResponseCodeInterpreterToolCallParam'
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__LocalShellCall
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__LocalShellCallOutput
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__ShellCall
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__ShellCallOutput
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__ApplyPatchCall
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__ApplyPatchCallOutput
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__McpListTools
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__McpApprovalRequest
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__McpApprovalResponse
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__McpCall
                  - $ref: '#/components/schemas/ResponseCustomToolCallOutputParam'
                  - $ref: '#/components/schemas/ResponseCustomToolCallParam'
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_param__ItemReference
              type: array
          title: Input
        instructions:
          type: string
          title: Instructions
        previous_response_id:
          type: string
          title: Previous Response Id
        stream:
          type: boolean
          title: Stream
        tools:
          items:
            anyOf:
              - $ref: '#/components/schemas/FunctionToolParam'
              - $ref: '#/components/schemas/FileSearchToolParam'
              - $ref: '#/components/schemas/ComputerToolParam'
              - $ref: '#/components/schemas/WebSearchToolParam'
              - $ref: '#/components/schemas/openai__types__responses__tool_param__Mcp'
              - $ref: >-
                  #/components/schemas/openai__types__responses__tool_param__CodeInterpreter
              - $ref: >-
                  #/components/schemas/openai__types__responses__tool_param__ImageGeneration
              - $ref: >-
                  #/components/schemas/openai__types__responses__tool_param__LocalShell
              - $ref: '#/components/schemas/FunctionShellToolParam'
              - $ref: '#/components/schemas/CustomToolParam'
              - $ref: '#/components/schemas/WebSearchPreviewToolParam'
              - $ref: '#/components/schemas/ApplyPatchToolParam'
          type: array
          title: Tools
        max_output_tokens:
          type: integer
          title: Max Output Tokens
        temperature:
          type: number
          title: Temperature
        top_p:
          type: number
          title: Top P
        chat_template:
          type: string
          title: Chat Template
        chat_template_kwargs:
          additionalProperties: true
          type: object
          title: Chat Template Kwargs
      additionalProperties: true
      type: object
      title: ResponsesRequest
      description: The JSON body sent to an OpenAI-compatible Responses endpoint.
    Response:
      properties:
        id:
          type: string
          title: Id
        created_at:
          type: number
          title: Created At
        error:
          anyOf:
            - $ref: '#/components/schemas/ResponseError'
            - type: 'null'
        incomplete_details:
          anyOf:
            - $ref: '#/components/schemas/IncompleteDetails'
            - type: 'null'
        instructions:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/EasyInputMessage'
                  - $ref: '#/components/schemas/Message'
                  - $ref: '#/components/schemas/ResponseOutputMessage'
                  - $ref: '#/components/schemas/ResponseFileSearchToolCall'
                  - $ref: '#/components/schemas/ResponseComputerToolCall'
                  - $ref: '#/components/schemas/ComputerCallOutput'
                  - $ref: '#/components/schemas/ResponseFunctionWebSearch'
                  - $ref: '#/components/schemas/ResponseFunctionToolCall'
                  - $ref: '#/components/schemas/FunctionCallOutput'
                  - $ref: '#/components/schemas/ResponseReasoningItem'
                  - $ref: '#/components/schemas/ResponseCompactionItemParam'
                  - $ref: '#/components/schemas/ImageGenerationCall'
                  - $ref: '#/components/schemas/ResponseCodeInterpreterToolCall'
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_input_item__LocalShellCall
                  - $ref: '#/components/schemas/LocalShellCallOutput'
                  - $ref: '#/components/schemas/ShellCall'
                  - $ref: '#/components/schemas/ShellCallOutput'
                  - $ref: '#/components/schemas/ApplyPatchCall'
                  - $ref: '#/components/schemas/ApplyPatchCallOutput'
                  - $ref: '#/components/schemas/McpListTools'
                  - $ref: '#/components/schemas/McpApprovalRequest'
                  - $ref: '#/components/schemas/McpApprovalResponse'
                  - $ref: '#/components/schemas/McpCall'
                  - $ref: '#/components/schemas/ResponseCustomToolCallOutput'
                  - $ref: '#/components/schemas/ResponseCustomToolCall'
                  - $ref: '#/components/schemas/ItemReference'
              type: array
            - type: 'null'
          title: Instructions
        metadata:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          title: Metadata
        model:
          anyOf:
            - type: string
            - type: string
              enum:
                - gpt-5.2
                - gpt-5.2-2025-12-11
                - gpt-5.2-chat-latest
                - gpt-5.2-pro
                - gpt-5.2-pro-2025-12-11
                - gpt-5.1
                - gpt-5.1-2025-11-13
                - gpt-5.1-codex
                - gpt-5.1-mini
                - gpt-5.1-chat-latest
                - gpt-5
                - gpt-5-mini
                - gpt-5-nano
                - gpt-5-2025-08-07
                - gpt-5-mini-2025-08-07
                - gpt-5-nano-2025-08-07
                - gpt-5-chat-latest
                - gpt-4.1
                - gpt-4.1-mini
                - gpt-4.1-nano
                - gpt-4.1-2025-04-14
                - gpt-4.1-mini-2025-04-14
                - gpt-4.1-nano-2025-04-14
                - o4-mini
                - o4-mini-2025-04-16
                - o3
                - o3-2025-04-16
                - o3-mini
                - o3-mini-2025-01-31
                - o1
                - o1-2024-12-17
                - o1-preview
                - o1-preview-2024-09-12
                - o1-mini
                - o1-mini-2024-09-12
                - gpt-4o
                - gpt-4o-2024-11-20
                - gpt-4o-2024-08-06
                - gpt-4o-2024-05-13
                - gpt-4o-audio-preview
                - gpt-4o-audio-preview-2024-10-01
                - gpt-4o-audio-preview-2024-12-17
                - gpt-4o-audio-preview-2025-06-03
                - gpt-4o-mini-audio-preview
                - gpt-4o-mini-audio-preview-2024-12-17
                - gpt-4o-search-preview
                - gpt-4o-mini-search-preview
                - gpt-4o-search-preview-2025-03-11
                - gpt-4o-mini-search-preview-2025-03-11
                - chatgpt-4o-latest
                - codex-mini-latest
                - gpt-4o-mini
                - gpt-4o-mini-2024-07-18
                - gpt-4-turbo
                - gpt-4-turbo-2024-04-09
                - gpt-4-0125-preview
                - gpt-4-turbo-preview
                - gpt-4-1106-preview
                - gpt-4-vision-preview
                - gpt-4
                - gpt-4-0314
                - gpt-4-0613
                - gpt-4-32k
                - gpt-4-32k-0314
                - gpt-4-32k-0613
                - gpt-3.5-turbo
                - gpt-3.5-turbo-16k
                - gpt-3.5-turbo-0301
                - gpt-3.5-turbo-0613
                - gpt-3.5-turbo-1106
                - gpt-3.5-turbo-0125
                - gpt-3.5-turbo-16k-0613
            - type: string
              enum:
                - o1-pro
                - o1-pro-2025-03-19
                - o3-pro
                - o3-pro-2025-06-10
                - o3-deep-research
                - o3-deep-research-2025-06-26
                - o4-mini-deep-research
                - o4-mini-deep-research-2025-06-26
                - computer-use-preview
                - computer-use-preview-2025-03-11
                - gpt-5-codex
                - gpt-5-pro
                - gpt-5-pro-2025-10-06
                - gpt-5.1-codex-max
          title: Model
        object:
          type: string
          const: response
          title: Object
        output:
          items:
            anyOf:
              - $ref: '#/components/schemas/ResponseOutputMessage'
              - $ref: '#/components/schemas/ResponseFileSearchToolCall'
              - $ref: '#/components/schemas/ResponseFunctionToolCall'
              - $ref: '#/components/schemas/ResponseFunctionWebSearch'
              - $ref: '#/components/schemas/ResponseComputerToolCall'
              - $ref: '#/components/schemas/ResponseReasoningItem'
              - $ref: '#/components/schemas/ResponseCompactionItem'
              - $ref: >-
                  #/components/schemas/openai__types__responses__response_output_item__ImageGenerationCall
              - $ref: '#/components/schemas/ResponseCodeInterpreterToolCall'
              - $ref: '#/components/schemas/LocalShellCall'
              - $ref: '#/components/schemas/ResponseFunctionShellToolCall'
              - $ref: '#/components/schemas/ResponseFunctionShellToolCallOutput'
              - $ref: '#/components/schemas/ResponseApplyPatchToolCall'
              - $ref: '#/components/schemas/ResponseApplyPatchToolCallOutput'
              - $ref: >-
                  #/components/schemas/openai__types__responses__response_output_item__McpCall
              - $ref: >-
                  #/components/schemas/openai__types__responses__response_output_item__McpListTools
              - $ref: >-
                  #/components/schemas/openai__types__responses__response_output_item__McpApprovalRequest
              - $ref: '#/components/schemas/ResponseCustomToolCall'
          type: array
          title: Output
        parallel_tool_calls:
          type: boolean
          title: Parallel Tool Calls
        temperature:
          anyOf:
            - type: number
            - type: 'null'
          title: Temperature
        tool_choice:
          anyOf:
            - type: string
              enum:
                - none
                - auto
                - required
            - $ref: '#/components/schemas/ToolChoiceAllowed'
            - $ref: '#/components/schemas/ToolChoiceTypes'
            - $ref: '#/components/schemas/ToolChoiceFunction'
            - $ref: '#/components/schemas/ToolChoiceMcp'
            - $ref: '#/components/schemas/ToolChoiceCustom'
            - $ref: '#/components/schemas/ToolChoiceApplyPatch'
            - $ref: '#/components/schemas/ToolChoiceShell'
          title: Tool Choice
        tools:
          items:
            anyOf:
              - $ref: '#/components/schemas/FunctionTool'
              - $ref: '#/components/schemas/FileSearchTool'
              - $ref: '#/components/schemas/ComputerTool'
              - $ref: '#/components/schemas/WebSearchTool'
              - $ref: '#/components/schemas/Mcp'
              - $ref: '#/components/schemas/CodeInterpreter'
              - $ref: '#/components/schemas/ImageGeneration'
              - $ref: '#/components/schemas/LocalShell'
              - $ref: '#/components/schemas/FunctionShellTool'
              - $ref: '#/components/schemas/CustomTool'
              - $ref: '#/components/schemas/WebSearchPreviewTool'
              - $ref: '#/components/schemas/ApplyPatchTool'
          type: array
          title: Tools
        top_p:
          anyOf:
            - type: number
            - type: 'null'
          title: Top P
        background:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Background
        conversation:
          anyOf:
            - $ref: '#/components/schemas/Conversation'
            - type: 'null'
        max_output_tokens:
          anyOf:
            - type: integer
            - type: 'null'
          title: Max Output Tokens
        max_tool_calls:
          anyOf:
            - type: integer
            - type: 'null'
          title: Max Tool Calls
        previous_response_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Previous Response Id
        prompt:
          anyOf:
            - $ref: '#/components/schemas/ResponsePrompt'
            - type: 'null'
        prompt_cache_key:
          anyOf:
            - type: string
            - type: 'null'
          title: Prompt Cache Key
        prompt_cache_retention:
          anyOf:
            - type: string
              enum:
                - in-memory
                - 24h
            - type: 'null'
          title: Prompt Cache Retention
        reasoning:
          anyOf:
            - $ref: '#/components/schemas/Reasoning'
            - type: 'null'
        safety_identifier:
          anyOf:
            - type: string
            - type: 'null'
          title: Safety Identifier
        service_tier:
          anyOf:
            - type: string
              enum:
                - auto
                - default
                - flex
                - scale
                - priority
            - type: 'null'
          title: Service Tier
        status:
          anyOf:
            - type: string
              enum:
                - completed
                - failed
                - in_progress
                - cancelled
                - queued
                - incomplete
            - type: 'null'
          title: Status
        text:
          anyOf:
            - $ref: '#/components/schemas/ResponseTextConfig'
            - type: 'null'
        top_logprobs:
          anyOf:
            - type: integer
            - type: 'null'
          title: Top Logprobs
        truncation:
          anyOf:
            - type: string
              enum:
                - auto
                - disabled
            - type: 'null'
          title: Truncation
        usage:
          anyOf:
            - $ref: '#/components/schemas/ResponseUsage'
            - type: 'null'
        user:
          anyOf:
            - type: string
            - type: 'null'
          title: User
      additionalProperties: true
      type: object
      required:
        - id
        - created_at
        - model
        - object
        - output
        - parallel_tool_calls
        - tool_choice
        - tools
      title: Response
    MessagesRequest:
      properties:
        model:
          type: string
          title: Model
        messages:
          items:
            $ref: '#/components/schemas/MessageParam'
          type: array
          title: Messages
        max_tokens:
          type: integer
          title: Max Tokens
        stream:
          type: boolean
          title: Stream
        system:
          anyOf:
            - type: string
            - items:
                $ref: '#/components/schemas/TextBlockParam'
              type: array
          title: System
        tools:
          items:
            anyOf:
              - $ref: '#/components/schemas/ToolParam'
              - $ref: '#/components/schemas/ToolBash20250124Param'
              - $ref: '#/components/schemas/CodeExecutionTool20250522Param'
              - $ref: '#/components/schemas/CodeExecutionTool20250825Param'
              - $ref: '#/components/schemas/CodeExecutionTool20260120Param'
              - $ref: '#/components/schemas/CodeExecutionTool20260521Param'
              - $ref: '#/components/schemas/MemoryTool20250818Param'
              - $ref: '#/components/schemas/ToolTextEditor20250124Param'
              - $ref: '#/components/schemas/ToolTextEditor20250429Param'
              - $ref: '#/components/schemas/ToolTextEditor20250728Param'
              - $ref: '#/components/schemas/WebSearchTool20250305Param'
              - $ref: '#/components/schemas/WebFetchTool20250910Param'
              - $ref: '#/components/schemas/WebSearchTool20260209Param'
              - $ref: '#/components/schemas/WebFetchTool20260209Param'
              - $ref: '#/components/schemas/WebFetchTool20260309Param'
              - $ref: '#/components/schemas/WebSearchTool20260318Param'
              - $ref: '#/components/schemas/WebFetchTool20260318Param'
              - $ref: '#/components/schemas/ToolSearchToolBm25_20251119Param'
              - $ref: '#/components/schemas/ToolSearchToolRegex20251119Param'
          type: array
          title: Tools
        thinking:
          anyOf:
            - $ref: '#/components/schemas/ThinkingConfigEnabledParam'
            - $ref: '#/components/schemas/ThinkingConfigDisabledParam'
            - $ref: '#/components/schemas/ThinkingConfigAdaptiveParam'
          title: Thinking
        temperature:
          type: number
          title: Temperature
        top_p:
          type: number
          title: Top P
        top_k:
          type: integer
          title: Top K
        stop_sequences:
          items:
            type: string
          type: array
          title: Stop Sequences
        chat_template:
          type: string
          title: Chat Template
        chat_template_kwargs:
          additionalProperties: true
          type: object
          title: Chat Template Kwargs
      additionalProperties: true
      type: object
      title: MessagesRequest
      description: The JSON body sent to an Anthropic-compatible Messages endpoint.
    anthropic__types__message__Message:
      properties:
        id:
          type: string
          title: Id
        container:
          anyOf:
            - $ref: '#/components/schemas/Container'
            - type: 'null'
        content:
          items:
            anyOf:
              - $ref: '#/components/schemas/TextBlock'
              - $ref: '#/components/schemas/ThinkingBlock'
              - $ref: '#/components/schemas/RedactedThinkingBlock'
              - $ref: '#/components/schemas/ToolUseBlock'
              - $ref: '#/components/schemas/ServerToolUseBlock'
              - $ref: '#/components/schemas/WebSearchToolResultBlock'
              - $ref: '#/components/schemas/WebFetchToolResultBlock'
              - $ref: '#/components/schemas/CodeExecutionToolResultBlock'
              - $ref: '#/components/schemas/BashCodeExecutionToolResultBlock'
              - $ref: '#/components/schemas/TextEditorCodeExecutionToolResultBlock'
              - $ref: '#/components/schemas/ToolSearchToolResultBlock'
              - $ref: '#/components/schemas/ContainerUploadBlock'
          type: array
          title: Content
        model:
          anyOf:
            - type: string
              enum:
                - claude-sonnet-5
                - claude-fable-5
                - claude-mythos-5
                - claude-opus-4-8
                - claude-opus-4-7
                - claude-mythos-preview
                - claude-opus-4-6
                - claude-sonnet-4-6
                - claude-haiku-4-5
                - claude-haiku-4-5-20251001
                - claude-opus-4-5
                - claude-opus-4-5-20251101
                - claude-sonnet-4-5
                - claude-sonnet-4-5-20250929
                - claude-opus-4-1
                - claude-opus-4-1-20250805
            - type: string
          title: Model
        role:
          type: string
          const: assistant
          title: Role
        stop_details:
          anyOf:
            - $ref: '#/components/schemas/RefusalStopDetails'
            - type: 'null'
        stop_reason:
          anyOf:
            - type: string
              enum:
                - end_turn
                - max_tokens
                - stop_sequence
                - tool_use
                - pause_turn
                - refusal
            - type: 'null'
          title: Stop Reason
        stop_sequence:
          anyOf:
            - type: string
            - type: 'null'
          title: Stop Sequence
        type:
          type: string
          const: message
          title: Type
        usage:
          $ref: '#/components/schemas/Usage'
      additionalProperties: true
      type: object
      required:
        - id
        - content
        - model
        - role
        - type
        - usage
      title: Message
    ImageURL:
      properties:
        url:
          type: string
          title: Url
        detail:
          type: string
          enum:
            - auto
            - low
            - high
          title: Detail
      additionalProperties: true
      type: object
      required:
        - url
      title: ImageURL
    InputAudio:
      properties:
        data:
          type: string
          title: Data
        format:
          type: string
          enum:
            - wav
            - mp3
          title: Format
      additionalProperties: true
      type: object
      required:
        - data
        - format
      title: InputAudio
    FileFile:
      properties:
        file_data:
          type: string
          title: File Data
        file_id:
          type: string
          title: File Id
        filename:
          type: string
          title: Filename
      additionalProperties: true
      type: object
      title: FileFile
    Function:
      properties:
        arguments:
          type: string
          title: Arguments
        name:
          type: string
          title: Name
      additionalProperties: true
      type: object
      required:
        - arguments
        - name
      title: Function
      description: The function that the model called.
    Custom:
      properties:
        input:
          type: string
          title: Input
        name:
          type: string
          title: Name
      additionalProperties: true
      type: object
      required:
        - input
        - name
      title: Custom
      description: The custom tool that the model called.
    ChatCompletionTokenLogprob:
      properties:
        token:
          type: string
          title: Token
        bytes:
          anyOf:
            - items:
                type: integer
              type: array
            - type: 'null'
          title: Bytes
        logprob:
          type: number
          title: Logprob
        top_logprobs:
          items:
            $ref: '#/components/schemas/TopLogprob'
          type: array
          title: Top Logprobs
      additionalProperties: true
      type: object
      required:
        - token
        - logprob
        - top_logprobs
      title: ChatCompletionTokenLogprob
    Annotation:
      properties:
        type:
          type: string
          const: url_citation
          title: Type
        url_citation:
          $ref: >-
            #/components/schemas/openai__types__chat__chat_completion_message__AnnotationURLCitation
      additionalProperties: true
      type: object
      required:
        - type
        - url_citation
      title: Annotation
      description: A URL citation when using web search.
    ChatCompletionAudio:
      properties:
        id:
          type: string
          title: Id
        data:
          type: string
          title: Data
        expires_at:
          type: integer
          title: Expires At
        transcript:
          type: string
          title: Transcript
      additionalProperties: true
      type: object
      required:
        - id
        - data
        - expires_at
        - transcript
      title: ChatCompletionAudio
      description: >-
        If the audio output modality is requested, this object contains data

        about the audio response from the model. [Learn
        more](https://platform.openai.com/docs/guides/audio).
    ChatCompletionMessageFunctionToolCall:
      properties:
        id:
          type: string
          title: Id
        function:
          $ref: '#/components/schemas/Function'
        type:
          type: string
          const: function
          title: Type
      additionalProperties: true
      type: object
      required:
        - id
        - function
        - type
      title: ChatCompletionMessageFunctionToolCall
      description: A call to a function tool created by the model.
    ChatCompletionMessageCustomToolCall:
      properties:
        id:
          type: string
          title: Id
        custom:
          $ref: '#/components/schemas/Custom'
        type:
          type: string
          const: custom
          title: Type
      additionalProperties: true
      type: object
      required:
        - id
        - custom
        - type
      title: ChatCompletionMessageCustomToolCall
      description: A call to a custom tool created by the model.
    CompletionUsage:
      properties:
        completion_tokens:
          type: integer
          title: Completion Tokens
        prompt_tokens:
          type: integer
          title: Prompt Tokens
        total_tokens:
          type: integer
          title: Total Tokens
        completion_tokens_details:
          anyOf:
            - $ref: '#/components/schemas/CompletionTokensDetails'
            - type: 'null'
        prompt_tokens_details:
          anyOf:
            - $ref: '#/components/schemas/PromptTokensDetails'
            - type: 'null'
      additionalProperties: true
      type: object
      required:
        - completion_tokens
        - prompt_tokens
        - total_tokens
      title: CompletionUsage
      description: Usage statistics for the completion request.
    CompletionChoice:
      properties:
        finish_reason:
          type: string
          enum:
            - stop
            - length
            - content_filter
          title: Finish Reason
        index:
          type: integer
          title: Index
        logprobs:
          anyOf:
            - $ref: '#/components/schemas/Logprobs'
            - type: 'null'
        text:
          type: string
          title: Text
      additionalProperties: true
      type: object
      required:
        - finish_reason
        - index
        - text
      title: CompletionChoice
    EasyInputMessageParam:
      properties:
        content:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ResponseInputTextParam'
                  - $ref: '#/components/schemas/ResponseInputImageParam'
                  - $ref: '#/components/schemas/ResponseInputFileParam'
              type: array
          title: Content
        role:
          type: string
          enum:
            - user
            - assistant
            - system
            - developer
          title: Role
        type:
          type: string
          const: message
          title: Type
      type: object
      required:
        - content
        - role
      title: EasyInputMessageParam
      description: >-
        A message input to the model with a role indicating instruction
        following

        hierarchy. Instructions given with the `developer` or `system` role take

        precedence over instructions given with the `user` role. Messages with
        the

        `assistant` role are presumed to have been generated by the model in
        previous

        interactions.
    openai__types__responses__response_input_param__Message:
      properties:
        content:
          items:
            anyOf:
              - $ref: '#/components/schemas/ResponseInputTextParam'
              - $ref: '#/components/schemas/ResponseInputImageParam'
              - $ref: '#/components/schemas/ResponseInputFileParam'
          type: array
          title: Content
        role:
          type: string
          enum:
            - user
            - system
            - developer
          title: Role
        status:
          type: string
          enum:
            - in_progress
            - completed
            - incomplete
          title: Status
        type:
          type: string
          const: message
          title: Type
      type: object
      required:
        - content
        - role
      title: Message
      description: >-
        A message input to the model with a role indicating instruction
        following

        hierarchy. Instructions given with the `developer` or `system` role take

        precedence over instructions given with the `user` role.
    ResponseOutputMessageParam:
      properties:
        id:
          type: string
          title: Id
        content:
          items:
            anyOf:
              - $ref: '#/components/schemas/ResponseOutputTextParam'
              - $ref: '#/components/schemas/ResponseOutputRefusalParam'
          type: array
          title: Content
        role:
          type: string
          const: assistant
          title: Role
        status:
          type: string
          enum:
            - in_progress
            - completed
            - incomplete
          title: Status
        type:
          type: string
          const: message
          title: Type
      type: object
      required:
        - id
        - content
        - role
        - status
        - type
      title: ResponseOutputMessageParam
      description: An output message from the model.
    ResponseFileSearchToolCallParam:
      properties:
        id:
          type: string
          title: Id
        queries:
          items:
            type: string
          type: array
          title: Queries
        status:
          type: string
          enum:
            - in_progress
            - searching
            - completed
            - incomplete
            - failed
          title: Status
        type:
          type: string
          const: file_search_call
          title: Type
        results:
          anyOf:
            - items:
                $ref: >-
                  #/components/schemas/openai__types__responses__response_file_search_tool_call_param__Result
              type: array
            - type: 'null'
          title: Results
      type: object
      required:
        - id
        - queries
        - status
        - type
      title: ResponseFileSearchToolCallParam
      description: >-
        The results of a file search tool call.


        See the

        [file search
        guide](https://platform.openai.com/docs/guides/tools-file-search) for
        more information.
    ResponseComputerToolCallParam:
      properties:
        id:
          type: string
          title: Id
        action:
          anyOf:
            - $ref: >-
                #/components/schemas/openai__types__responses__response_computer_tool_call_param__ActionClick
            - $ref: >-
                #/components/schemas/openai__types__responses__response_computer_tool_call_param__ActionDoubleClick
            - $ref: >-
                #/components/schemas/openai__types__responses__response_computer_tool_call_param__ActionDrag
            - $ref: >-
                #/components/schemas/openai__types__responses__response_computer_tool_call_param__ActionKeypress
            - $ref: >-
                #/components/schemas/openai__types__responses__response_computer_tool_call_param__ActionMove
            - $ref: >-
                #/components/schemas/openai__types__responses__response_computer_tool_call_param__ActionScreenshot
            - $ref: >-
                #/components/schemas/openai__types__responses__response_computer_tool_call_param__ActionScroll
            - $ref: >-
                #/components/schemas/openai__types__responses__response_computer_tool_call_param__ActionType
            - $ref: >-
                #/components/schemas/openai__types__responses__response_computer_tool_call_param__ActionWait
          title: Action
        call_id:
          type: string
          title: Call Id
        pending_safety_checks:
          items:
            $ref: >-
              #/components/schemas/openai__types__responses__response_computer_tool_call_param__PendingSafetyCheck
          type: array
          title: Pending Safety Checks
        status:
          type: string
          enum:
            - in_progress
            - completed
            - incomplete
          title: Status
        type:
          type: string
          const: computer_call
          title: Type
      type: object
      required:
        - id
        - action
        - call_id
        - pending_safety_checks
        - status
        - type
      title: ResponseComputerToolCallParam
      description: >-
        A tool call to a computer use tool.


        See the

        [computer use
        guide](https://platform.openai.com/docs/guides/tools-computer-use) for
        more information.
    openai__types__responses__response_input_param__ComputerCallOutput:
      properties:
        call_id:
          type: string
          title: Call Id
        output:
          $ref: '#/components/schemas/ResponseComputerToolCallOutputScreenshotParam'
        type:
          type: string
          const: computer_call_output
          title: Type
        id:
          anyOf:
            - type: string
            - type: 'null'
          title: Id
        acknowledged_safety_checks:
          anyOf:
            - items:
                $ref: >-
                  #/components/schemas/openai__types__responses__response_input_param__ComputerCallOutputAcknowledgedSafetyCheck
              type: array
            - type: 'null'
          title: Acknowledged Safety Checks
        status:
          anyOf:
            - type: string
              enum:
                - in_progress
                - completed
                - incomplete
            - type: 'null'
          title: Status
      type: object
      required:
        - call_id
        - output
        - type
      title: ComputerCallOutput
      description: The output of a computer tool call.
    ResponseFunctionWebSearchParam:
      properties:
        id:
          type: string
          title: Id
        action:
          anyOf:
            - $ref: >-
                #/components/schemas/openai__types__responses__response_function_web_search_param__ActionSearch
            - $ref: >-
                #/components/schemas/openai__types__responses__response_function_web_search_param__ActionOpenPage
            - $ref: >-
                #/components/schemas/openai__types__responses__response_function_web_search_param__ActionFind
          title: Action
        status:
          type: string
          enum:
            - in_progress
            - searching
            - completed
            - failed
          title: Status
        type:
          type: string
          const: web_search_call
          title: Type
      type: object
      required:
        - id
        - action
        - status
        - type
      title: ResponseFunctionWebSearchParam
      description: >-
        The results of a web search tool call.


        See the

        [web search
        guide](https://platform.openai.com/docs/guides/tools-web-search) for
        more information.
    ResponseFunctionToolCallParam:
      properties:
        arguments:
          type: string
          title: Arguments
        call_id:
          type: string
          title: Call Id
        name:
          type: string
          title: Name
        type:
          type: string
          const: function_call
          title: Type
        id:
          type: string
          title: Id
        status:
          type: string
          enum:
            - in_progress
            - completed
            - incomplete
          title: Status
      type: object
      required:
        - arguments
        - call_id
        - name
        - type
      title: ResponseFunctionToolCallParam
      description: >-
        A tool call to run a function.


        See the

        [function calling
        guide](https://platform.openai.com/docs/guides/function-calling) for
        more information.
    openai__types__responses__response_input_param__FunctionCallOutput:
      properties:
        call_id:
          type: string
          title: Call Id
        output:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ResponseInputTextContentParam'
                  - $ref: '#/components/schemas/ResponseInputImageContentParam'
                  - $ref: '#/components/schemas/ResponseInputFileContentParam'
              type: array
          title: Output
        type:
          type: string
          const: function_call_output
          title: Type
        id:
          anyOf:
            - type: string
            - type: 'null'
          title: Id
        status:
          anyOf:
            - type: string
              enum:
                - in_progress
                - completed
                - incomplete
            - type: 'null'
          title: Status
      type: object
      required:
        - call_id
        - output
        - type
      title: FunctionCallOutput
      description: The output of a function tool call.
    ResponseReasoningItemParam:
      properties:
        id:
          type: string
          title: Id
        summary:
          items:
            $ref: >-
              #/components/schemas/openai__types__responses__response_reasoning_item_param__Summary
          type: array
          title: Summary
        type:
          type: string
          const: reasoning
          title: Type
        content:
          items:
            $ref: >-
              #/components/schemas/openai__types__responses__response_reasoning_item_param__Content
          type: array
          title: Content
        encrypted_content:
          anyOf:
            - type: string
            - type: 'null'
          title: Encrypted Content
        status:
          type: string
          enum:
            - in_progress
            - completed
            - incomplete
          title: Status
      type: object
      required:
        - id
        - summary
        - type
      title: ResponseReasoningItemParam
      description: >-
        A description of the chain of thought used by a reasoning model while
        generating

        a response. Be sure to include these items in your `input` to the
        Responses API

        for subsequent turns of a conversation if you are manually

        [managing
        context](https://platform.openai.com/docs/guides/conversation-state).
    ResponseCompactionItemParamParam:
      properties:
        encrypted_content:
          type: string
          title: Encrypted Content
        type:
          type: string
          const: compaction
          title: Type
        id:
          anyOf:
            - type: string
            - type: 'null'
          title: Id
      type: object
      required:
        - encrypted_content
        - type
      title: ResponseCompactionItemParamParam
      description: >-
        A compaction item generated by the [`v1/responses/compact`
        API](https://platform.openai.com/docs/api-reference/responses/compact).
    openai__types__responses__response_input_param__ImageGenerationCall:
      properties:
        id:
          type: string
          title: Id
        result:
          anyOf:
            - type: string
            - type: 'null'
          title: Result
        status:
          type: string
          enum:
            - in_progress
            - completed
            - generating
            - failed
          title: Status
        type:
          type: string
          const: image_generation_call
          title: Type
      type: object
      required:
        - id
        - result
        - status
        - type
      title: ImageGenerationCall
      description: An image generation request made by the model.
    ResponseCodeInterpreterToolCallParam:
      properties:
        id:
          type: string
          title: Id
        code:
          anyOf:
            - type: string
            - type: 'null'
          title: Code
        container_id:
          type: string
          title: Container Id
        outputs:
          anyOf:
            - items:
                anyOf:
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_code_interpreter_tool_call_param__OutputLogs
                  - $ref: >-
                      #/components/schemas/openai__types__responses__response_code_interpreter_tool_call_param__OutputImage
              type: array
            - type: 'null'
          title: Outputs
        status:
          type: string
          enum:
            - in_progress
            - completed
            - incomplete
            - interpreting
            - failed
          title: Status
        type:
          type: string
          const: code_interpreter_call
          title: Type
      type: object
      required:
        - id
        - code
        - container_id
        - outputs
        - status
        - type
      title: ResponseCodeInterpreterToolCallParam
      description: A tool call to run code.
    openai__types__responses__response_input_param__LocalShellCall:
      properties:
        id:
          type: string
          title: Id
        action:
          $ref: >-
            #/components/schemas/openai__types__responses__response_input_param__LocalShellCallAction
        call_id:
          type: string
          title: Call Id
        status:
          type: string
          enum:
            - in_progress
            - completed
            - incomplete
          title: Status
        type:
          type: string
          const: local_shell_call
          title: Type
      type: object
      required:
        - id
        - action
        - call_id
        - status
        - type
      title: LocalShellCall
      description: A tool call to run a command on the local shell.
    openai__types__responses__response_input_param__LocalShellCallOutput:
      properties:
        id:
          type: string
          title: Id
        output:
          type: string
          title: Output
        type:
          type: string
          const: local_shell_call_output
          title: Type
        status:
          anyOf:
            - type: string
              enum:
                - in_progress
                - completed
                - incomplete
            - type: 'null'
          title: Status
      type: object
      required:
        - id
        - output
        - type
      title: LocalShellCallOutput
      description: The output of a local shell tool call.
    openai__types__responses__response_input_param__ShellCall:
      properties:
        action:
          $ref: >-
            #/components/schemas/openai__types__responses__response_input_param__ShellCallAction
        call_id:
          type: string
          title: Call Id
        type:
          type: string
          const: shell_call
          title: Type
        id:
          anyOf:
            - type: string
            - type: 'null'
          title: Id
        status:
          anyOf:
            - type: string
              enum:
                - in_progress
                - completed
                - incomplete
            - type: 'null'
          title: Status
      type: object
      required:
        - action
        - call_id
        - type
      title: ShellCall
      description: A tool representing a request to execute one or more shell commands.
    openai__types__responses__response_input_param__ShellCallOutput:
      properties:
        call_id:
          type: string
          title: Call Id
        output:
          items:
            $ref: '#/components/schemas/ResponseFunctionShellCallOutputContentParam'
          type: array
          title: Output
        type:
          type: string
          const: shell_call_output
          title: Type
        id:
          anyOf:
            - type: string
            - type: 'null'
          title: Id
        max_output_length:
          anyOf:
            - type: integer
            - type: 'null'
          title: Max Output Length
      type: object
      required:
        - call_id
        - output
        - type
      title: ShellCallOutput
      description: The streamed output items emitted by a shell tool call.
    openai__types__responses__response_input_param__ApplyPatchCall:
      properties:
        call_id:
          type: string
          title: Call Id
        operation:
          anyOf:
            - $ref: >-
                #/components/schemas/openai__types__responses__response_input_param__ApplyPatchCallOperationCreateFile
            - $ref: >-
                #/components/schemas/openai__types__responses__response_input_param__ApplyPatchCallOperationDeleteFile
            - $ref: >-
                #/components/schemas/openai__types__responses__response_input_param__ApplyPatchCallOperationUpdateFile
          title: Operation
        status:
          type: string
          enum:
            - in_progress
            - completed
          title: Status
        type:
          type: string
          const: apply_patch_call
          title: Type
        id:
          anyOf:
            - type: string
            - type: 'null'
          title: Id
      type: object
      required:
        - call_id
        - operation
        - status
        - type
      title: ApplyPatchCall
      description: >-
        A tool call representing a request to create, delete, or update files
        using diff patches.
    openai__types__responses__response_input_param__ApplyPatchCallOutput:
      properties:
        call_id:
          type: string
          title: Call Id
        status:
          type: string
          enum:
            - completed
            - failed
          title: Status
        type:
          type: string
          const: apply_patch_call_output
          title: Type
        id:
          anyOf:
            - type: string
            - type: 'null'
          title: Id
        output:
          anyOf:
            - type: string
            - type: 'null'
          title: Output
      type: object
      required:
        - call_id
        - status
        - type
      title: ApplyPatchCallOutput
      description: The streamed output emitted by an apply patch tool call.
    openai__types__responses__response_input_param__McpListTools:
      properties:
        id:
          type: string
          title: Id
        server_label:
          type: string
          title: Server Label
        tools:
          items:
            $ref: >-
              #/components/schemas/openai__types__responses__response_input_param__McpListToolsTool
          type: array
          title: Tools
        type:
          type: string
          const: mcp_list_tools
          title: Type
        error:
          anyOf:
            - type: string
            - type: 'null'
          title: Error
      type: object
      required:
        - id
        - server_label
        - tools
        - type
      title: McpListTools
      description: A list of tools available on an MCP server.
    openai__types__responses__response_input_param__McpApprovalRequest:
      properties:
        id:
          type: string
          title: Id
        arguments:
          type: string
          title: Arguments
        name:
          type: string
          title: Name
        server_label:
          type: string
          title: Server Label
        type:
          type: string
          const: mcp_approval_request
          title: Type
      type: object
      required:
        - id
        - arguments
        - name
        - server_label
        - type
      title: McpApprovalRequest
      description: A request for human approval of a tool invocation.
    openai__types__responses__response_input_param__McpApprovalResponse:
      properties:
        approval_request_id:
          type: string
          title: Approval Request Id
        approve:
          type: boolean
          title: Approve
        type:
          type: string
          const: mcp_approval_response
          title: Type
        id:
          anyOf:
            - type: string
            - type: 'null'
          title: Id
        reason:
          anyOf:
            - type: string
            - type: 'null'
          title: Reason
      type: object
      required:
        - approval_request_id
        - approve
        - type
      title: McpApprovalResponse
      description: A response to an MCP approval request.
    openai__types__responses__response_input_param__McpCall:
      properties:
        id:
          type: string
          title: Id
        arguments:
          type: string
          title: Arguments
        name:
          type: string
          title: Name
        server_label:
          type: string
          title: Server Label
        type:
          type: string
          const: mcp_call
          title: Type
        approval_request_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Approval Request Id
        error:
          anyOf:
            - type: string
            - type: 'null'
          title: Error
        output:
          anyOf:
            - type: string
            - type: 'null'
          title: Output
        status:
          type: string
          enum:
            - in_progress
            - completed
            - incomplete
            - calling
            - failed
          title: Status
      type: object
      required:
        - id
        - arguments
        - name
        - server_label
        - type
      title: McpCall
      description: An invocation of a tool on an MCP server.
    ResponseCustomToolCallOutputParam:
      properties:
        call_id:
          type: string
          title: Call Id
        output:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ResponseInputTextParam'
                  - $ref: '#/components/schemas/ResponseInputImageParam'
                  - $ref: '#/components/schemas/ResponseInputFileParam'
              type: array
          title: Output
        type:
          type: string
          const: custom_tool_call_output
          title: Type
        id:
          type: string
          title: Id
      type: object
      required:
        - call_id
        - output
        - type
      title: ResponseCustomToolCallOutputParam
      description: >-
        The output of a custom tool call from your code, being sent back to the
        model.
    ResponseCustomToolCallParam:
      properties:
        call_id:
          type: string
          title: Call Id
        input:
          type: string
          title: Input
        name:
          type: string
          title: Name
        type:
          type: string
          const: custom_tool_call
          title: Type
        id:
          type: string
          title: Id
      type: object
      required:
        - call_id
        - input
        - name
        - type
      title: ResponseCustomToolCallParam
      description: A call to a custom tool created by the model.
    openai__types__responses__response_input_param__ItemReference:
      properties:
        id:
          type: string
          title: Id
        type:
          anyOf:
            - type: string
              const: item_reference
            - type: 'null'
          title: Type
      type: object
      required:
        - id
      title: ItemReference
      description: An internal identifier for an item to reference.
    FunctionToolParam:
      properties:
        name:
          type: string
          title: Name
        parameters:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Parameters
        strict:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Strict
        type:
          type: string
          const: function
          title: Type
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
      type: object
      required:
        - name
        - parameters
        - strict
        - type
      title: FunctionToolParam
      description: >-
        Defines a function in your own code the model can choose to call.


        Learn more about [function
        calling](https://platform.openai.com/docs/guides/function-calling).
    FileSearchToolParam:
      properties:
        type:
          type: string
          const: file_search
          title: Type
        vector_store_ids:
          items:
            type: string
          type: array
          title: Vector Store Ids
        filters:
          anyOf:
            - $ref: >-
                #/components/schemas/openai__types__shared_params__comparison_filter__ComparisonFilter
            - $ref: >-
                #/components/schemas/openai__types__shared_params__compound_filter__CompoundFilter
            - type: 'null'
          title: Filters
        max_num_results:
          type: integer
          title: Max Num Results
        ranking_options:
          $ref: >-
            #/components/schemas/openai__types__responses__file_search_tool_param__RankingOptions
      type: object
      required:
        - type
        - vector_store_ids
      title: FileSearchToolParam
      description: >-
        A tool that searches for relevant content from uploaded files.


        Learn more about the [file search
        tool](https://platform.openai.com/docs/guides/tools-file-search).
    ComputerToolParam:
      properties:
        display_height:
          type: integer
          title: Display Height
        display_width:
          type: integer
          title: Display Width
        environment:
          type: string
          enum:
            - windows
            - mac
            - linux
            - ubuntu
            - browser
          title: Environment
        type:
          type: string
          const: computer_use_preview
          title: Type
      type: object
      required:
        - display_height
        - display_width
        - environment
        - type
      title: ComputerToolParam
      description: >-
        A tool that controls a virtual computer.


        Learn more about the [computer
        tool](https://platform.openai.com/docs/guides/tools-computer-use).
    WebSearchToolParam:
      properties:
        type:
          type: string
          enum:
            - web_search
            - web_search_2025_08_26
          title: Type
        filters:
          anyOf:
            - $ref: >-
                #/components/schemas/openai__types__responses__web_search_tool_param__Filters
            - type: 'null'
        search_context_size:
          type: string
          enum:
            - low
            - medium
            - high
          title: Search Context Size
        user_location:
          anyOf:
            - $ref: >-
                #/components/schemas/openai__types__responses__web_search_tool_param__UserLocation
            - type: 'null'
      type: object
      required:
        - type
      title: WebSearchToolParam
      description: >-
        Search the Internet for sources related to the prompt.


        Learn more about the

        [web search
        tool](https://platform.openai.com/docs/guides/tools-web-search).
    openai__types__responses__tool_param__Mcp:
      properties:
        server_label:
          type: string
          title: Server Label
        type:
          type: string
          const: mcp
          title: Type
        allowed_tools:
          anyOf:
            - items:
                type: string
              type: array
            - $ref: >-
                #/components/schemas/openai__types__responses__tool_param__McpAllowedToolsMcpToolFilter
            - type: 'null'
          title: Allowed Tools
        authorization:
          type: string
          title: Authorization
        connector_id:
          type: string
          enum:
            - connector_dropbox
            - connector_gmail
            - connector_googlecalendar
            - connector_googledrive
            - connector_microsoftteams
            - connector_outlookcalendar
            - connector_outlookemail
            - connector_sharepoint
          title: Connector Id
        headers:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          title: Headers
        require_approval:
          anyOf:
            - $ref: >-
                #/components/schemas/openai__types__responses__tool_param__McpRequireApprovalMcpToolApprovalFilter
            - type: string
              enum:
                - always
                - never
            - type: 'null'
          title: Require Approval
        server_description:
          type: string
          title: Server Description
        server_url:
          type: string
          title: Server Url
      type: object
      required:
        - server_label
        - type
      title: Mcp
      description: >-
        Give the model access to additional tools via remote Model Context
        Protocol

        (MCP) servers. [Learn more about
        MCP](https://platform.openai.com/docs/guides/tools-remote-mcp).
    openai__types__responses__tool_param__CodeInterpreter:
      properties:
        container:
          anyOf:
            - type: string
            - $ref: >-
                #/components/schemas/openai__types__responses__tool_param__CodeInterpreterContainerCodeInterpreterToolAuto
          title: Container
        type:
          type: string
          const: code_interpreter
          title: Type
      type: object
      required:
        - container
        - type
      title: CodeInterpreter
      description: A tool that runs Python code to help generate a response to a prompt.
    openai__types__responses__tool_param__ImageGeneration:
      properties:
        type:
          type: string
          const: image_generation
          title: Type
        background:
          type: string
          enum:
            - transparent
            - opaque
            - auto
          title: Background
        input_fidelity:
          anyOf:
            - type: string
              enum:
                - high
                - low
            - type: 'null'
          title: Input Fidelity
        input_image_mask:
          $ref: >-
            #/components/schemas/openai__types__responses__tool_param__ImageGenerationInputImageMask
        model:
          anyOf:
            - type: string
            - type: string
              enum:
                - gpt-image-1
                - gpt-image-1-mini
          title: Model
        moderation:
          type: string
          enum:
            - auto
            - low
          title: Moderation
        output_compression:
          type: integer
          title: Output Compression
        output_format:
          type: string
          enum:
            - png
            - webp
            - jpeg
          title: Output Format
        partial_images:
          type: integer
          title: Partial Images
        quality:
          type: string
          enum:
            - low
            - medium
            - high
            - auto
          title: Quality
        size:
          type: string
          enum:
            - 1024x1024
            - 1024x1536
            - 1536x1024
            - auto
          title: Size
      type: object
      required:
        - type
      title: ImageGeneration
      description: A tool that generates images using the GPT image models.
    openai__types__responses__tool_param__LocalShell:
      properties:
        type:
          type: string
          const: local_shell
          title: Type
      type: object
      required:
        - type
      title: LocalShell
      description: >-
        A tool that allows the model to execute shell commands in a local
        environment.
    FunctionShellToolParam:
      properties:
        type:
          type: string
          const: shell
          title: Type
      type: object
      required:
        - type
      title: FunctionShellToolParam
      description: A tool that allows the model to execute shell commands.
    CustomToolParam:
      properties:
        name:
          type: string
          title: Name
        type:
          type: string
          const: custom
          title: Type
        description:
          type: string
          title: Description
        format:
          anyOf:
            - $ref: >-
                #/components/schemas/openai__types__shared_params__custom_tool_input_format__Text
            - $ref: >-
                #/components/schemas/openai__types__shared_params__custom_tool_input_format__Grammar
          title: Format
      type: object
      required:
        - name
        - type
      title: CustomToolParam
      description: >-
        A custom tool that processes input using a specified format.


        Learn more about   [custom
        tools](https://platform.openai.com/docs/guides/function-calling#custom-tools)
    WebSearchPreviewToolParam:
      properties:
        type:
          type: string
          enum:
            - web_search_preview
            - web_search_preview_2025_03_11
          title: Type
        search_context_size:
          type: string
          enum:
            - low
            - medium
            - high
          title: Search Context Size
        user_location:
          anyOf:
            - $ref: >-
                #/components/schemas/openai__types__responses__web_search_preview_tool_param__UserLocation
            - type: 'null'
      type: object
      required:
        - type
      title: WebSearchPreviewToolParam
      description: >-
        This tool searches the web for relevant results to use in a response.


        Learn more about the [web search
        tool](https://platform.openai.com/docs/guides/tools-web-search).
    ApplyPatchToolParam:
      properties:
        type:
          type: string
          const: apply_patch
          title: Type
      type: object
      required:
        - type
      title: ApplyPatchToolParam
      description: >-
        Allows the assistant to create, delete, or update files using unified
        diffs.
    ResponseError:
      properties:
        code:
          type: string
          enum:
            - server_error
            - rate_limit_exceeded
            - invalid_prompt
            - vector_store_timeout
            - invalid_image
            - invalid_image_format
            - invalid_base64_image
            - invalid_image_url
            - image_too_large
            - image_too_small
            - image_parse_error
            - image_content_policy_violation
            - invalid_image_mode
            - image_file_too_large
            - unsupported_image_media_type
            - empty_image_file
            - failed_to_download_image
            - image_file_not_found
          title: Code
        message:
          type: string
          title: Message
      additionalProperties: true
      type: object
      required:
        - code
        - message
      title: ResponseError
      description: An error object returned when the model fails to generate a Response.
    IncompleteDetails:
      properties:
        reason:
          anyOf:
            - type: string
              enum:
                - max_output_tokens
                - content_filter
            - type: 'null'
          title: Reason
      additionalProperties: true
      type: object
      title: IncompleteDetails
      description: Details about why the response is incomplete.
    EasyInputMessage:
      properties:
        content:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ResponseInputText'
                  - $ref: '#/components/schemas/ResponseInputImage'
                  - $ref: '#/components/schemas/ResponseInputFile'
              type: array
          title: Content
        role:
          type: string
          enum:
            - user
            - assistant
            - system
            - developer
          title: Role
        type:
          anyOf:
            - type: string
              const: message
            - type: 'null'
          title: Type
      additionalProperties: true
      type: object
      required:
        - content
        - role
      title: EasyInputMessage
      description: >-
        A message input to the model with a role indicating instruction
        following

        hierarchy. Instructions given with the `developer` or `system` role take

        precedence over instructions given with the `user` role. Messages with
        the

        `assistant` role are presumed to have been generated by the model in
        previous

        interactions.
    Message:
      properties:
        content:
          items:
            anyOf:
              - $ref: '#/components/schemas/ResponseInputText'
              - $ref: '#/components/schemas/ResponseInputImage'
              - $ref: '#/components/schemas/ResponseInputFile'
          type: array
          title: Content
        role:
          type: string
          enum:
            - user
            - system
            - developer
          title: Role
        status:
          anyOf:
            - type: string
              enum:
                - in_progress
                - completed
                - incomplete
            - type: 'null'
          title: Status
        type:
          anyOf:
            - type: string
              const: message
            - type: 'null'
          title: Type
      additionalProperties: true
      type: object
      required:
        - content
        - role
      title: Message
      description: >-
        A message input to the model with a role indicating instruction
        following

        hierarchy. Instructions given with the `developer` or `system` role take

        precedence over instructions given with the `user` role.
    ResponseOutputMessage:
      properties:
        id:
          type: string
          title: Id
        content:
          items:
            anyOf:
              - $ref: '#/components/schemas/ResponseOutputText'
              - $ref: '#/components/schemas/ResponseOutputRefusal'
          type: array
          title: Content
        role:
          type: string
          const: assistant
          title: Role
        status:
          type: string
          enum:
            - in_progress
            - completed
            - incomplete
          title: Status
        type:
          type: string
          const: message
          title: Type
      additionalProperties: true
      type: object
      required:
        - id
        - content
        - role
        - status
        - type
      title: ResponseOutputMessage
      description: An output message from the model.
    ResponseFileSearchToolCall:
      properties:
        id:
          type: string
          title: Id
        queries:
          items:
            type: string
          type: array
          title: Queries
        status:
          type: string
          enum:
            - in_progress
            - searching
            - completed
            - incomplete
            - failed
          title: Status
        type:
          type: string
          const: file_search_call
          title: Type
        results:
          anyOf:
            - items:
                $ref: '#/components/schemas/Result'
              type: array
            - type: 'null'
          title: Results
      additionalProperties: true
      type: object
      required:
        - id
        - queries
        - status
        - type
      title: ResponseFileSearchToolCall
      description: >-
        The results of a file search tool call.


        See the

        [file search
        guide](https://platform.openai.com/docs/guides/tools-file-search) for
        more information.
    ResponseComputerToolCall:
      properties:
        id:
          type: string
          title: Id
        action:
          anyOf:
            - $ref: '#/components/schemas/ActionClick'
            - $ref: '#/components/schemas/ActionDoubleClick'
            - $ref: '#/components/schemas/ActionDrag'
            - $ref: '#/components/schemas/ActionKeypress'
            - $ref: '#/components/schemas/ActionMove'
            - $ref: '#/components/schemas/ActionScreenshot'
            - $ref: '#/components/schemas/ActionScroll'
            - $ref: '#/components/schemas/ActionType'
            - $ref: '#/components/schemas/ActionWait'
          title: Action
        call_id:
          type: string
          title: Call Id
        pending_safety_checks:
          items:
            $ref: '#/components/schemas/PendingSafetyCheck'
          type: array
          title: Pending Safety Checks
        status:
          type: string
          enum:
            - in_progress
            - completed
            - incomplete
          title: Status
        type:
          type: string
          const: computer_call
          title: Type
      additionalProperties: true
      type: object
      required:
        - id
        - action
        - call_id
[...]
